#include <execution>
#include <unistd.h>
#include <iostream>
#include <thread>
using namespace std;

atomic<int> tctr;
void doStuff(int i)
{
  // this allows us to print how many threads are processing in parallel
  cout<< to_string(tctr++)+": Processing " + to_string(i) <<endl;
  usleep(250000);
  tctr--;
}

int main()
{
  vector<int> input({1,2,3,4,5,6,7,8,9,10});

  for(const auto& i : input) {
    doStuff(i);
  }

  cout<<"----------"<<endl;
  
  std::for_each(std::execution::par, input.cbegin(), input.cend(), doStuff);

  cout<<"----------"<<endl;
  
  atomic<size_t> ctr=0;
  auto worker = [&ctr, &input]() {
    for(size_t n = ctr++; n < input.size(); n = ctr++)
      doStuff(input.at(n));
  };

  vector<thread> workers;
  for(int n=0; n < 4; ++n)
    workers.emplace_back(worker);
  
  for(auto& w : workers)
    w.join();

  cout<<"----------"<<endl;
  
  input.reserve(100000000);
  for(int n=0; n < 100000000; ++n)
    input.push_back(random());
  
  cout<<"----------"<<endl;
  sort(std::execution::par, input.begin(), input.end());  
}
